"""pytop - le dados estatisticos da cpu/discos"""

import psutil
import os
import time
from datetime import datetime

data = datetime.now().strftime('%Y-%m-%d')
name_file = "/sig/logs/{data}-pytop.txt".format(data=data)
tempo = 60
disco = '/'
identificador = 'CpuHouse-14'
versao = '2'
saida = '1'  # 1=arquivo, 2=tcp-ip

def get_average():
    if psutil.__version__ < '5.6.2':
        os.system('uptime > /tmp/u.txt')
        file = open('/tmp/u.txt', 'r')
        line = file.readline()
        file.close()
        linha = line.replace('\n', '').replace(',', '').split(' ')
        return float(linha[-3]), float(linha[-2]), float(linha[-1])
    else:
        return psutil.getloadavg()


while True:
    CPU_cores = psutil.cpu_count()
    data = datetime.now().strftime('%Y-%m-%d %H:%M:%S')
    l1, l2, l3 = get_average()
    CPU_use1 = (l1/CPU_cores) * 100
    CPU_use2 = (l2/CPU_cores) * 100
    CPU_use3 = (l3/CPU_cores) * 100
    l1 = float('%.2f' % l1)
    l2 = float('%.2f' % l2)
    l3 = float('%.2f' % l3)
    CPU_use1 = float('%.2f' % CPU_use1)
    CPU_use2 = float('%.2f' % CPU_use2)
    CPU_use3 = float('%.2f' % CPU_use3)
    psusage = psutil.disk_usage(disco)
    DSK_total = psusage.total
    DSK_percent = psusage.percent
    psio = psutil.disk_io_counters(perdisk=False)
    DSK_read_count = psio.read_count
    DSK_write_count = psio.write_count
    DSK_read_bytes = psio.read_bytes
    DSK_write_bytes = psio.write_bytes
    psmem = psutil.virtual_memory()
    MEM_total = psmem.total
    MEN_percent = psmem.percent

    if versao == '1':
        linha = '{data};{CPU_use1};{CPU_use2};{CPU_use3};{l1};{l2};{l3}\n'.format(data=data,CPU_use1=CPU_use1,CPU_use2=CPU_use2,CPU_use3=CPU_use3,l1=l1,l2=l2,l3=l3)
        cab_linha = 'data_hora;cpu1;cpu2;cpu3;av1;av2;av3\n'
    elif versao == '2':
        linha = '{versao};{identificador};{data};{CPU_cores};{CPU_use1};{CPU_use2};{CPU_use3};{l1};{l2};{l3};{DSK_total};{DSK_percent};{DSK_read_count};{DSK_write_count};{DSK_read_bytes};{DSK_write_bytes}\n'.format(data=data,CPU_cores=CPU_cores,CPU_use1=CPU_use1,CPU_use2=CPU_use2,CPU_use3=CPU_use3,l1=l1,l2=l2,l3=l3,DSK_total=DSK_total,DSK_percent=DSK_percent,DSK_read_count=DSK_read_count,DSK_write_count=DSK_write_count,DSK_read_bytes=DSK_read_bytes,DSK_write_bytes=DSK_write_bytes,identificador=identificador,versao=versao) 
        cab_linha = 'versao;identificador;data_hora;cpu_cores;cpu1;cpu2;cpu3;av1;av2;av3;dsk_total;dsk_perc;dsk_read_count;dsk_write_count;dsk_read_bytes;dsk_write_bytes\n'
    else:
        linha = '{versao};{identificador};{data};{CPU_cores};{l1};{l2};{l3};{DSK_total};{DSK_percent};{DSK_read_count};{DSK_write_count};{DSK_read_bytes};{DSK_write_bytes}\n'.format(data=data,CPU_cores=CPU_cores,l1=l1,l2=l2,l3=l3,DSK_total=DSK_total,DSK_percent=DSK_percent,DSK_read_count=DSK_read_count,DSK_write_count=DSK_write_count,DSK_read_bytes=DSK_read_bytes,DSK_write_bytes=DSK_write_bytes,identificador=identificador,versao=versao) 
        cab_linha = 'versao;identificador;data_hora;cpu_cores;av1;av2;av3;dsk_total;dsk_perc;dsk_read_count;dsk_write_count;dsk_read_bytes;dsk_write_bytes\n'
    if saida == '1':
        cab = True
        if os.path.exists(name_file):
            cab = False
        file = open(name_file, 'a')
        if cab:
            file.write(cab_linha)
        file.write(linha)

    time.sleep(tempo)
